Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/RectangularPackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/RectangularPackingShape.cs	(revision 14042)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.2D/3.3/RectangularPackingShape.cs	(revision 14043)
@@ -33,5 +33,5 @@
   [Item("RectangularPackingShape", "Represents the rectangular measures (width, height) of a two-dimensional bin-packing object.")]
   [StorableClass]
-  public abstract class RectangularPackingShape : PackingShape<TwoDimensionalPacking>, IRegularPackingShape, IComparable<RectangularPackingShape> {
+  public abstract class RectangularPackingShape : PackingShape<TwoDimensionalPacking>, IComparable<RectangularPackingShape> {
     public int Height {
       get { return ((IFixedValueParameter<IntValue>)Parameters["Height"]).Value.Value; }
@@ -73,5 +73,5 @@
     }
 
-    public int CompareTo(object obj) {
+    public override int CompareTo(object obj) {
       var other = obj as RectangularPackingShape;
       if (other != null) return CompareTo(other);
@@ -118,5 +118,5 @@
     }
 
-    public void ApplyHorizontalOrientation() {
+    public override void ApplyHorizontalOrientation() {
       if (Width < Height) {
         var aux = Width;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/CuboidPackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/CuboidPackingShape.cs	(revision 14042)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking.3D/3.3/CuboidPackingShape.cs	(revision 14043)
@@ -32,5 +32,5 @@
   [Item("CuboidPackingShape", "Represents the cuboid measures (width, height, depth) of a three-dimensional cuboidic bin-packing object.")]
   [StorableClass]
-  public abstract class CuboidPackingShape : PackingShape<ThreeDimensionalPacking>, IRegularPackingShape, IComparable<CuboidPackingShape> {
+  public abstract class CuboidPackingShape : PackingShape<ThreeDimensionalPacking>, IComparable<CuboidPackingShape> {
     public IFixedValueParameter<IntValue> HeightParameter {
       get { return (IFixedValueParameter<IntValue>)Parameters["Height"]; }
@@ -110,5 +110,5 @@
     }
 
-    public int CompareTo(object obj) {
+    public override int CompareTo(object obj) {
       var other = (CuboidPackingShape)obj;
       if (other != null) return CompareTo(other);
@@ -179,5 +179,5 @@
     }
 
-    public void ApplyHorizontalOrientation() {
+    public override void ApplyHorizontalOrientation() {
       if (Width > Depth) {
         var aux = Width;
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Analyzers/BestBinPackingSolutionAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Analyzers/BestBinPackingSolutionAnalyzer.cs	(revision 14042)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Analyzers/BestBinPackingSolutionAnalyzer.cs	(revision 14043)
@@ -38,6 +38,6 @@
   public class BestBinPackingSolutionAnalyzer<D, B, I> : BinPackingAnalyzer<D, B, I>, IStochasticOperator
     where D : class, IPackingDimensions
-    where B : PackingShape<D>, IPackingBin, IRegularPackingShape
-    where I : PackingShape<D>, IPackingItem, IRegularPackingShape {
+    where B : PackingShape<D>, IPackingBin
+    where I : PackingShape<D>, IPackingItem {
 
     public ILookupParameter<IRandom> RandomParameter {
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/BinPackingProblem.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/BinPackingProblem.cs	(revision 14042)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/BinPackingProblem.cs	(revision 14043)
@@ -43,6 +43,6 @@
   public abstract class BinPackingProblem<D, B, I> : SingleObjectiveHeuristicOptimizationProblem<IPackingPlanEvaluationAlgorithm, IPackingSolutionCreator> 
     where D : class, IPackingDimensions 
-    where B : PackingShape<D>, IPackingBin, IRegularPackingShape, new()
-    where I : PackingShape<D>, IPackingItem, IRegularPackingShape, new () {
+    where B : PackingShape<D>, IPackingBin, new()
+    where I : PackingShape<D>, IPackingItem, new () {
 
 
@@ -150,5 +150,5 @@
     protected void ApplyHorizontalOrientation() {
       PackingBinMeasures.ApplyHorizontalOrientation();
-      foreach (IRegularPackingShape shape in PackingItemMeasures) {
+      foreach (IPackingShape shape in PackingItemMeasures) {
         shape.ApplyHorizontalOrientation();
       }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/BinUtilizationRegularIdenticalBinEvaluator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/BinUtilizationRegularIdenticalBinEvaluator.cs	(revision 14042)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/BinUtilizationRegularIdenticalBinEvaluator.cs	(revision 14043)
@@ -34,6 +34,6 @@
   public abstract class BinUtilizationRegularIdenticalBinEvaluator<D, B, I> : RegularSimpleRotationIdenticalBinPackingPlanEvaluator<D, B, I>
     where D : class, IPackingDimensions
-    where B : PackingShape<D>, IPackingBin, IRegularPackingShape
-    where I : PackingShape<D>, IPackingItem, IRegularPackingShape {
+    where B : PackingShape<D>, IPackingBin
+    where I : PackingShape<D>, IPackingItem {
 
     [StorableConstructor]
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/PackingRatioRegularIdenticalBinEvaluator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/PackingRatioRegularIdenticalBinEvaluator.cs	(revision 14042)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/PackingRatioRegularIdenticalBinEvaluator.cs	(revision 14043)
@@ -34,6 +34,6 @@
   public abstract class PackingRatioRegularIdenticalBinEvaluator<D, B, I> : RegularSimpleRotationIdenticalBinPackingPlanEvaluator<D, B, I>
     where D : class, IPackingDimensions
-    where B : PackingShape<D>, IPackingBin, IRegularPackingShape
-    where I : PackingShape<D>, IPackingItem, IRegularPackingShape {
+    where B : PackingShape<D>, IPackingBin
+    where I : PackingShape<D>, IPackingItem {
 
     [StorableConstructor]
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/RegularSimpleRotationIdenticalBinPackingPlanEvaluator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/RegularSimpleRotationIdenticalBinPackingPlanEvaluator.cs	(revision 14042)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Evaluators/RegularSimpleRotationIdenticalBinPackingPlanEvaluator.cs	(revision 14043)
@@ -33,6 +33,6 @@
   public abstract class RegularSimpleRotationIdenticalBinPackingPlanEvaluator<D, B, I> : PackingPlanEvaluator<D, B, I>
     where D : class, IPackingDimensions
-    where B : PackingShape<D>, IPackingBin, IRegularPackingShape
-    where I : PackingShape<D>, IPackingItem, IRegularPackingShape {
+    where B : PackingShape<D>, IPackingBin
+    where I : PackingShape<D>, IPackingItem {
 
     #region Parameter Properties
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj	(revision 14042)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj	(revision 14043)
@@ -282,5 +282,4 @@
     <Compile Include="PackingDimensions.cs" />
     <Compile Include="PackingMoveEvaluator.cs" />
-    <Compile Include="Interfaces\IRegularPackingShape.cs" />
     <Compile Include="Interfaces\IPackingBin.cs" />
     <Compile Include="Interfaces\IPackingItem.cs" />
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/IPackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/IPackingShape.cs	(revision 14042)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/IPackingShape.cs	(revision 14043)
@@ -20,4 +20,5 @@
 #endregion
 
+using System;
 using HeuristicLab.Core;
 
@@ -25,4 +26,7 @@
   // a packing shape represents a physical object of correct dimension (2d or 3d) 
   // packing bins (containers) and packing items are both packing shapes
-  public interface IPackingShape : IItem { }
+  public interface IPackingShape : IItem, IComparable {
+    int Volume { get; }
+    void ApplyHorizontalOrientation();
+  }
 }
Index: anches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/IRegularPackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Interfaces/IRegularPackingShape.cs	(revision 14042)
+++ 	(revision )
@@ -1,30 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Joseph Helm and Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-
-namespace HeuristicLab.Problems.BinPacking.Interfaces {
-  ///A regularPackingShape has special geometric properties that allow special handling = Rectangle, Cuboid
-  public interface IRegularPackingShape : IPackingShape, IComparable {
-    int Volume { get; }
-    void ApplyHorizontalOrientation();
-  }
-}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/PackingMoveEvaluator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/PackingMoveEvaluator.cs	(revision 14042)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/PackingMoveEvaluator.cs	(revision 14043)
@@ -38,6 +38,6 @@
   public abstract class PackingMoveEvaluator<D, B, I> : SingleSuccessorOperator, IPackingMoveEvaluator, IMoveOperator
     where D : class, IPackingDimensions
-    where B : PackingShape<D>, IPackingBin, IRegularPackingShape
-    where I : PackingShape<D>, IPackingItem, IRegularPackingShape {     
+    where B : PackingShape<D>, IPackingBin
+    where I : PackingShape<D>, IPackingItem {     
     public override bool CanChangeName {
       get { return false; }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/PackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/PackingShape.cs	(revision 14042)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/PackingShape.cs	(revision 14043)
@@ -79,4 +79,7 @@
     }
 
+    public abstract void ApplyHorizontalOrientation();
+    public abstract int CompareTo(object obj);
+
     public IKeyedItemCollection<string, IParameter> Parameters { get; private set; }
   }
Index: /branches/HeuristicLab.BinPacking/old files/IRegularPackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/old files/IRegularPackingShape.cs	(revision 14043)
+++ /branches/HeuristicLab.BinPacking/old files/IRegularPackingShape.cs	(revision 14043)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Joseph Helm and Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Problems.BinPacking.Interfaces {
+  ///A regularPackingShape has special geometric properties that allow special handling = Rectangle, Cuboid
+  public interface IRegularPackingShape : IPackingShape, IComparable {
+
+  }
+}